/* attendanceadmins v1.4 */

#include <amxmodx>
#include <amxmisc>

#define PLUGIN "attendanceadmins"
#define VERSION "1.4A4"
#define AUTHOR "ZETA [M|E|N]"

//arg+
#define ATTENDANCE_LEVEL ADMIN_RESERVATION
//arg-

new attendancemotd[2501],statisticsmotd[2501]
new attendanceini[81],attendancetxt[81]
new statisticsini[81],statisticstxt[81]
new attendanceold[81],statisticsold[81]

new adminname[32],adminip[21],gamedate[6],gametime
new regname[32],regip[21],regdate[6],regtime
new awrite,swrite,attendancetime,statstime

new str_today[3],today,str_month[3],month,oldmonth
new addmotd[211],attendance[81],text[81],line,num
new param[40],str_regtime[7]

//arg+
new g_notimer = 1
//arg-

public plugin_init() {
	register_plugin(PLUGIN,VERSION,AUTHOR)
	register_clcmd("say /attendance","func_say_attendance",ADMIN_LEVEL_A,"")
	register_clcmd("say /statistics","func_say_statistics",ADMIN_LEVEL_A,"")
	register_clcmd("attendance","func_console_attendance",ADMIN_LEVEL_A,"")
	register_clcmd("attendancetime","func_console_attendancetime",ADMIN_LEVEL_A,"")

	//arg+
	register_clcmd("adm","func_console_attendance",ADMIN_LEVEL_A,"")
	register_concmd("adm", "func_console_attendance", ADMIN_LEVEL_A,"")
	//arg-
}

public plugin_cfg() {
	get_configsdir(attendanceini,81) 
	get_configsdir(attendancetxt,81)
	get_configsdir(statisticsini,81)
	get_configsdir(statisticstxt,81)
	format(attendanceini,80,"%s/attendanceadmins/attendance.ini",attendanceini)
	format(attendancetxt,80,"%s/attendanceadmins/attendance.txt",attendancetxt)
	format(statisticsini,80,"%s/attendanceadmins/statistics.ini",statisticsini)
	format(statisticstxt,80,"%s/attendanceadmins/statistics.txt",statisticstxt)
	
	get_time("%d.%m",gamedate,5)
	get_time("%d",str_today,2);today=str_to_num(str_today)
	
	if(today==1) {
		get_time("%m",str_month,2);month=str_to_num(str_month)
		oldmonth=month-1
		
		format(attendanceold,80,"%s/attendanceadmins/attendance%s%d.ini",attendanceini,oldmonth<10 ? "0":"",oldmonth)
		format(statisticsold,80,"%s/attendanceadmins/statistics%s%d.ini",statisticsini,oldmonth<10 ? "0":"",oldmonth)
		rename_file(attendanceini,attendanceold)
		rename_file(statisticsini,statisticsold)
		
		write_file(attendanceini,"",-1)
		write_file(statisticsini,"",-1)
	}
}

//arg+
public client_infochanged(id)
{
	if ((!is_user_connected(id)) || ((!access(id, ATTENDANCE_LEVEL))))
		return PLUGIN_CONTINUE

	g_notimer = 0
	admin_vizit(id)

	return PLUGIN_CONTINUE
}

public client_disconnect(id)
{
	if (!(access(id, ATTENDANCE_LEVEL)))
		return PLUGIN_CONTINUE

	g_notimer = 1
	admin_vizit(id)

	return PLUGIN_CONTINUE
}
//arg-

//arg+
public admin_vizit(id) {
//	if(is_user_admin(id)) {
//	if(access(id, ADMIN_RESERVATION)) { // ne toka adminov no i reser sloti
//arg-
		awrite=0;swrite=0
		//arg+
		//get_user_name(id,adminname,sizeof(adminname))
		get_user_info(id, "name", adminname, 31)
		//arg-
		get_user_ip(id,adminip,sizeof(adminip),1)

		//arg+
		if (g_notimer) gametime=get_user_time(id,1)/60
			else gametime=0
		//arg-

		get_time("%d.%m",gamedate,5)
		
		for(line=0;read_file(attendanceini,line,text,81,num);line++) {
			if(num>0&&text[0]!=';') {
				parse(text,regdate,5,regname,sizeof(regname),regip,sizeof(regip),str_regtime,6)
				if(equali(gamedate,regdate)&&(equali(adminname,regname)||equali(adminip,regip))) {
					regtime=str_to_num(str_regtime);attendancetime=regtime+gametime
					//arg+
					get_user_name(id,adminname,sizeof(adminname))
					//arg-
					
					format(attendance,80,"^"%s^" ^"%s^" ^"%s^" ^"%d^"",gamedate,adminname,adminip,attendancetime)
					write_file(attendanceini,attendance,line);awrite=1
				}
			}
		}
		if(awrite!=1) {
			format(attendance,80,"^"%s^" ^"%s^" ^"%s^" ^"%d^"",gamedate,adminname,adminip,gametime)
			write_file(attendanceini,attendance,-1)
		}
		
		for(line=0;read_file(statisticsini,line,text,81,num);line++) {
			if(num>0&&text[0]!=';') {
				parse(text,regname,sizeof(regname),regip,sizeof(regip),str_regtime,6)
				if(equali(adminname,regname)||equali(adminip,regip)) {
					regtime=str_to_num(str_regtime);statstime=regtime+gametime
					//arg+
					get_user_name(id,adminname,sizeof(adminname))
					//arg-
					
					format(attendance,80,"^"%s^" ^"%s^" ^"%d^"",adminname,adminip,statstime)
					write_file(statisticsini,attendance,line);swrite=1
				}
			}
		}
		if(swrite!=1) {
		format(attendance,80,"^"%s^" ^"%s^" ^"%d^"",adminname,adminip,gametime)
		write_file(statisticsini,attendance,-1)
		}
//	}
		return PLUGIN_HANDLED
}

public func_say_attendance(id,level,cid) {
	if(!cmd_access(id,level,cid,0))
	return PLUGIN_HANDLED
	
	delete_file(attendancetxt)
	format(attendancemotd,2500,"<html><body bgcolor=^"#000000^" text=^"#FFB000^"><center>  %s",gamedate)
	add(attendancemotd,2500,"<table width=550 border=1 cellpadding=0 cellspacing=0><tr><td width=200>&nbsp;</td><td width=150>&nbsp;IP</td><td width=200>&nbsp;  </td></tr>")
	
	for(line=0;read_file(attendanceini,line,text,81,num);line++) {
		if(num>0&&text[0]!=';') {
			parse(text,regdate,5,regname,sizeof(regname),regip,sizeof(regip),str_regtime,6)
			if(equali(regdate,gamedate)) {
				regtime=str_to_num(str_regtime)
				
				format(addmotd,120,"<tr><td>&nbsp;%s</td><td>&nbsp;%s</td><td>&nbsp;%d .</td></tr>",regname,regip,regtime)
				add(attendancemotd,2500,addmotd)
			}
		}
	}
	add(attendancemotd,2500,"</table>")
	write_file(attendancetxt,attendancemotd,-1)
	
	show_motd(id,attendancetxt,"attendanceadmins")
	return PLUGIN_HANDLED
}

public func_say_statistics(id,level,cid) {
	if(!cmd_access(id,level,cid,0))
	return PLUGIN_HANDLED
	
	delete_file(statisticstxt)
	format(statisticsmotd,2500,"<html><body bgcolor=^"#000000^" text=^"#FFB000^"><center><table width=550 border=1 cellpadding=0 cellspacing=0><tr><td width=200>&nbsp;</td><td width=150>&nbsp;IP</td><td width=200>&nbsp;  </td></tr>")

	for(line=0;read_file(statisticsini,line,text,81,num);line++) {
		if(num>0&&text[0]!=';') {
			parse(text,regname,sizeof(regname),regip,sizeof(regip),str_regtime,6);regtime=str_to_num(str_regtime)
			format(addmotd,210,"<tr><td>&nbsp;%s</td><td>&nbsp;%s</td><td>&nbsp;%d .</td></tr>",regname,regip,regtime)
			add(statisticsmotd,2500,addmotd)
		}
	}
	add(attendancemotd,2500,"</table>")
	write_file(statisticstxt,statisticsmotd,-1)
	
	show_motd(id,statisticstxt,"statisticsadmins")
	return PLUGIN_HANDLED
}

public func_console_attendance(id,level,cid) {
	if(!cmd_access(id,level,cid,0))
		return PLUGIN_HANDLED
	
	read_argv(1,param,sizeof(param))
	
	if(!equali(param,"")) {
		client_print(id,print_console,"===========================================")
		client_print(id,print_console,"Дата   # Имя            # IP                # Время на сервере")
		for(line=0;read_file(attendanceini,line,text,81,num);line++) {
			if(num>0&&text[0]!=';') {
				parse(text,regdate,5,regname,sizeof(regname),regip,sizeof(regip),str_regtime,6)
				if(equali(param,regname)||equali(param,regip)||equali(param,regdate)) {
					regtime=str_to_num(str_regtime)

					//client_print(id,print_console,"%s  # %s  		# %s  	# %d мин.",regdate,regname,regip,regtime)
					console_print(id,"%s  # %s  		# %s  	# %d min.",regdate,regname,regip,regtime)
				}
			}
		}
		client_print(id,print_console,"===========================================")
	}
	else {
		client_print(id,print_console,"===========================================")
		client_print(id,print_console,"Дата   # Имя            # IP                # Время на сервере")
		for(line=0;read_file(attendanceini,line,text,81,num);line++) {
			if(num>0&&text[0]!=';') {
				parse(text,regdate,5,regname,sizeof(regname),regip,sizeof(regip),str_regtime,6)
				regtime=str_to_num(str_regtime)
					
				//client_print(id,print_console,"%s  # %s  		# %s  	# %d мин.",regdate,regname,regip,regtime)
				console_print(id,"%s  # %s  		# %s  	# %d min.",regdate,regname,regip,regtime)
			}
		}
		client_print(id,print_console,"===========================================")
	}
	return PLUGIN_HANDLED
}

public func_console_attendancetime(id,level,cid) {
	if(!cmd_access(id,level,cid,0))
	return PLUGIN_HANDLED
	
	new sign[2],str_timevalue[6],timevalue
	read_argv(1,param,sizeof(param))
	
	if(!equali(param,"")) {
		parse(param,sign,1,str_timevalue,sizeof(str_timevalue)) 
		timevalue=str_to_num(str_timevalue)
		
		if(equali(sign,"<")) {
			client_print(id,print_console,"===========================================")
			client_print(id,print_console,"Дата   # Имя            # IP                # Время на сервере")
			for(line=0;read_file(attendanceini,line,text,81,num);line++) {
				if(num>0&&text[0]!=';') {
					parse(text,regdate,5,regname,sizeof(regname),regip,sizeof(regip),str_regtime,6)
					regtime=str_to_num(str_regtime)
					if(regtime<timevalue) { 

						//client_print(id,print_console,"%s  # %s  # %s  # %d мин.",regdate,regname,regip,regtime)
						console_print(id,"%s  # %s  # %s  # %d min.",regdate,regname,regip,regtime)
					}
				}
			}
			client_print(id,print_console,"===========================================")
			return PLUGIN_HANDLED
		}
		if(equali(sign,">")) {
			client_print(id,print_console,"===========================================")
			client_print(id,print_console,"Дата   # Имя            # IP                # Время на сервере")
			for(line=0;read_file(attendanceini,line,text,81,num);line++) {
				if(num>0&&text[0]!=';') {
					parse(text,regdate,5,regname,sizeof(regname),regip,sizeof(regip),str_regtime,6)
					regtime=str_to_num(str_regtime)
					if(regtime>timevalue) {

						//client_print(id,print_console,"%s  # %s  # %s  # %d мин.",regdate,regname,regip,regtime)
						console_print(id,"%s  # %s  # %s  # %d min.",regdate,regname,regip,regtime)
					}
				}
			}
			client_print(id,print_console,"===========================================")
			return PLUGIN_HANDLED
		}
	}
	return PLUGIN_HANDLED
}
